package org.computer.aman.io;


import java.io.File;
import java.io.FileNotFoundException;
import java.util.LinkedList;
import java.util.List;

/**
 * Υǥ쥯ȥʲˤե򤹤٤ƸĤФ
 * ʥ֥ǥ쥯ȥʲˤեޤˤεǽ󶡡
 * 
 * <p>
 * <u><b>(1) ȥǥ쥯ȥʲեΥꥹȤ</b></u>
 * 
 * <pre>
 * FileFinder <i>finder</i> = new FileFinder(); 
 * List&lt;String&gt; <i>list</i> = <i>finder</i>.getList();
 * </pre>
 * 
 * <p>
 * <u><b>(2) ǥ쥯ȥ /foo/bar ʲ *.java եΥꥹȤ</b></u>
 * 
 * <pre>
 * FileFinder <i>finder</i> = new FileFinder(<i>/foo/bar</i>); 
 * List&lt;String&gt; <i>list</i> = <i>finder</i>.getList(<i>".+\\.java"</i>);
 * </pre>
 * 
 * @author Hirohisa AMAN &lt;aman@computer.org&gt;
 * @version 1.0
 * ($Id: FileFinder.java,v 1.4 2008/08/12 03:32:09 aman Exp $)
 */
public class FileFinder
{
    /** 
     * ȥǥ쥯ȥ롼ȤȤե븡֥Ȥ
     * 
     * @throws FileNotFoundException ȥǥ쥯ȥ꤬ץꥱˤäƳʤ
     */
    public FileFinder() throws FileNotFoundException
    {
        this(".");	
    }
    
    /**
     * ꤵ줿ǥ쥯ȥ롼ȤȤե븡֥Ȥ
     * @param aRootDir ǥ쥯ȥѥ
     * @throws FileNotFoundException ꤵ줿ǥ쥯ȥ꤬ʤ
     */
    public FileFinder(final String aRootDir) throws FileNotFoundException
    {
        setDirectory(aRootDir);
    }
    
    /**
     * ĥ꡼Υ롼ȤȤꤵƤǥ쥯ȥѥ֤
     * 
     * @return ĥ꡼Υ롼ȤȤꤵƤǥ쥯ȥѥ
     */
    public String getDirectory()
    {
        return directory.getPath();
    }
    
    /**
     * ĥ꡼ʲˤեΥꥹȤ֤
     * 
     * @return ĥ꡼ʲˤեΥꥹ
     * @throws FileNotFoundException ĥ꡼ʲ˳ʤǥ쥯ȥ꤬ä
     */
    public List<String> getList() throws FileNotFoundException
    {
        return getList(".+");
    }
    
    /**
     * ĥ꡼ʲˤեΥꥹȤ֤
     * 
     * @param aPattern ե̾Υޥå󥰤˻Ȥɽ
     * @return ĥ꡼ʲˤեΥꥹ
     * @throws FileNotFoundException ĥ꡼ʲ˳ʤǥ쥯ȥ꤬ä
     */
    public List<String> getList(final String aPattern) throws FileNotFoundException
    {
        if ( list == null ){
            search(aPattern);
        }        
        return list;        
    }
    
    /**
     * ĥ꡼Υ롼ȤȤʤǥ쥯ȥꤹ
     * 
     * @param aDirectory ǥ쥯ȥѥ
     * @throws FileNotFoundException ꤵ줿ǥ쥯ȥ꤬ʤ
     */
    public void setDirectory(final String aDirectory) throws FileNotFoundException
    {
        directory = new File(aDirectory);
        list = null;

        if ( directory.isFile() ){ // ꤵ줿ѥեä
            // ñƤǥꥹȤäƤ
            list = new LinkedList<String>();
            list.add(directory.getPath());
        }
        else if ( !directory.canRead() ){ // ꤵ줿ǥ쥯ȥ꤬ʤä
            throw new FileNotFoundException("could not open : " + aDirectory);
        }
    }
    
    /**
     * ĥ꡼ʲˤեΥꥹȤ
     * 
     * @param aPattern ѥɽ
     * @throws FileNotFoundException ĥ꡼ʲ˳ʤǥ쥯ȥ꤬ä
     */
    private void search(final String aPattern) throws FileNotFoundException
    {
        list = new LinkedList<String>();
        
        String[] files = directory.list();
        for ( int i = 0; i < files.length; i++ ){
            File f = new File(directory.getPath() + File.separator + files[i]);
            if ( f.isDirectory() ){
                FileFinder subFinder = new FileFinder(f.getPath());
                list.addAll(subFinder.getList(aPattern));
            }
            else if ( f.getPath().matches(aPattern) ) {                
                list.add(f.getPath());
            }
        }
    }
    
    /** ĥ꡼Υ롼ȤȤʤǥ쥯ȥ */
    private File directory;
    
    /** ̡ʥեΥꥹȡ */
    private List<String> list;
}
