package org.computer.aman.metrics.size.loc;

import java.io.IOException;
import java.math.BigInteger;
import java.util.Iterator;
import java.util.List;

import org.computer.aman.io.FileFinder;
import org.computer.aman.io.sourcecode.NotSupportedSourceFileExeption;
import org.computer.aman.io.sourcecode.SourceFile;

/**
 * LOCCounter Υȥ
 * <p>
 * @author Hirohisa AMAN &lt;aman@computer.org&gt;
 * @version $Id: LOCCounter.java,v 1.4 2009/03/27 07:22:20 aman Exp $
 */
public class LOCCounter
{
    public static void main(String[] args) 
    throws SecurityException, IOException, NotSupportedSourceFileExeption
    {
    	System.err.println("LOCCounter version 0.5");
        System.err.println("Copyright (C) 2008-2009 Hirohisa AMAN <aman@computer.org>");
    	System.err.println("----------------------------------------------------------------");
    	
    	// ץβ
    	// - target : оݥե or ǥ쥯ȥ
    	// - mode : ư⡼
    	//    0 : ʥץʤLOC ͤΤߤ
    	//    1 : -t ԿΤߤ
    	//    2 : -a LOC ͤԿξ
    	//    3 : -d ƥĤޤƤ٤Ƥɽ
    	//    ʣξϺǸ˻ꤷΤͭ
    	int mode = 0;    	    	
    	String target = null;    	
    	for ( int i = 0; i < args.length; i++ ){
    		if ( args[i].startsWith("-") ){
    			if ( args[i].equals("-t") ){
    				mode = 1;
    			}
    			else if ( args[i].equals("-a") ){
    				mode = 2;
    			}
    			else if ( args[i].equals("-d") ){
    				mode = 3;
    			}
    			else{
    			    // ̤ץξ --> Ȥɽƽλ
    				printUsage();
    				return;
    			}
    		}
    		else{
    			target = args[i];
    			break;
    		}
    	}
    	
    	// ꤵ줿ե or ǥ쥯ȥ꤫顤оݤ Java եꥹȤ
        // - ̤ξ --> Ȥɽƽλ
    	if ( target == null ){
    		printUsage();
    		return;
    	}    	
    	List<String> list = (new FileFinder(target)).getList(".+\\.(java|JAVA|c|C|h|H|cpp|CPP|cc|CC|cxx|CXX|m|M|i|I|ii|II)$");
    	
        // ƥեФ LOC ¬ȷ̤νϤ¹ 
    	// ¹ԸˡȡΥե LOC ͡Կ⥵ޥ꡼Ȥƽ
    	//   絬ϥեȥξ LOC ͡Կ礭ʤǽΤ 
    	//   BigInteger ֥Ȥ
        BigInteger totalLOC = new BigInteger("0");
        BigInteger totalLineCount = new BigInteger("0");
    	for (Iterator<String> iterator = list.iterator(); iterator.hasNext();) {
    	    // ¬μ¹
            LOCResultSet results = LOC.measure(new SourceFile(iterator.next()));

            // ¬̤Ѥɽ
            totalLOC = totalLOC.add(BigInteger.valueOf(results.getLOC()));
            totalLineCount = totalLineCount.add(BigInteger.valueOf(results.getTotalLineCount()));
            System.out.print(results.getSourceFile().getPath() + ",");
            switch ( mode ){
            case 0: 
                System.out.println(results.getLOC());
                break;
            case 1:
                System.out.println(results.getTotalLineCount());
                break;
            case 2:
            case 3:
                System.out.println(results.getLOC() + "," + results.getTotalLineCount() + "," + results.getBlankCount());
                if ( mode == 3 ){
                    System.err.println(results);        	
                }
            }
    	}    	
        System.err.println("----------------------------------------------------------------");
    	System.err.println("ե = " + list.size() + ", " +
    	                   " LOC = " + totalLOC + ", " +
    	                   "Կ = " + totalLineCount);
    }

    /**
     * Ȥɸ२顼ϤؽϤ
     */
    private static void printUsage()
    {
		System.err.println("java -jar LOCCounter.jar [option] (ե | ǥ쥯ȥ)");
		System.err.println("option : ");
		System.err.println("  ̵ : LOC ͤɽ");    				
		System.err.println("   -t : Կɽ");
		System.err.println("   -a : LOC ͤԿξɽ");
		System.err.println("   -d : ƥĤޤƤ٤Ƥɽ");
		System.err.println();
		System.err.println("ɽϤ줾ʲ̤ꡥǥ쥯ȥϤη֤Ȥʤ롥");
        System.err.println("  ̵  ե̾,LOC");
        System.err.println("  -t  ե̾,Կ");
		System.err.println("  -a  ե̾,LOC,Կ,Կ");
        System.err.println("  -d  -a ƱǽϤӾܺ٤ɸ२顼Ϥؽ");
    }
}
