package org.computer.aman.metrics.util;

import java.io.FileReader;
import java.io.IOException;
import java.io.LineNumberReader;

import org.computer.aman.io.sourcecode.NotSupportedSourceFileExeption;
import org.computer.aman.io.sourcecode.SourceFile;

/**
 * Java ɤƤɽɥޥå
 * <p>
 * ɥޥåפϡɤƤʸñ̤ɽޥåפǤ롥<br>
 * Ǥϡ
 * <ul>
 *  <li> : 0
 *  <li> 餫Υ: 1
 *  <li> // : 2
 *  <li> /* : 3
 *  <li> Javadoc: 4
 * </ul>
 * Ȥ롥
 * <p>
 * ܥ饹Υ󥹥󥹤Ǥϡ
 * ԤȤΥɥޥåץ֥ȡCodeLineMapForJava 󥹥󥹡ˤꥹȤȤݻ롥
 * 
 * @author Hirohisa AMAN &lt;aman@computer.org&gt;
 * @version $Id: CodeMapForJava.java,v 1.1 2009/03/26 04:48:32 aman Exp $
 */
public class CodeMapForJava extends CodeMap
{
    /**
     * Java եб CodeMap ֥Ȥ
     * 
     * @param aSourceFile ե
     * @throws NotSupportedSourceFileExeption ե뤬 Java Ǥʤ
     * @throws IOException Ϥǲ餫㳰ȯ
     */
    public CodeMapForJava(final SourceFile aSourceFile) 
    throws NotSupportedSourceFileExeption, IOException
    {
        if ( !aSourceFile.getExtension().equalsIgnoreCase("java") ){
            throw new NotSupportedSourceFileExeption();
        }
        
        // status - ɲϤξ
        //   0 : 
        //   1 : 餫ͭʥɤɤ߽Ф
        //   11: EOL ȡ//...
        //   12: Traditional ȡ/* ... 
        //   13: Javadoc (/** ... )
        //   100: ʸƥ"..."
        int status = 0; 

        // 1 Ԥɤ߹ߡƤˤĤĴ٤ʤ CodeLineMap  CodeMap ɲäƤ
        LineNumberReader reader = new LineNumberReader(new FileReader(aSourceFile));
        String line = null;
        StringBuffer map = new StringBuffer(); // CodeLineMap 夲뤿κ StringBuffer
        
        while ( (line = reader.readLine()) != null ){
            // ԤȤ CodeLineMap 夲뤿ᡤǽƤ򥯥ꥢƤ
            map.delete(0, map.length());
            
            // ιԤ˲餫ͭʥɤޤޤ뤫ݤΥե饰Ѱ
            boolean isCodeIncluded = false;
            
            // 1 ʸĴ١֤ܤƤ
            int i = 0;
            while ( i < line.length() ){    
                char ch = line.charAt(i);                
                if ( Character.isWhitespace(ch) ){ 
                    // ξ硤ΤȤޥåפ˵Ͽưʹߤϥåפ
                    map.append(CodeLineMap.BLANK);
                    i++;
                    continue;
                }
                switch ( status ){
                case 0: // 
                case 1: // ̾Υ
                    switch ( ch ){
                    case '/' :  // ȳϤβǽ
                        //  1 ʸĴ٤Ƽξ֤ꤹ                     
                        i++;
                        status = 1; // ǥեȤϸݻ
                        if ( i < line.length() ){
                            ch = line.charAt(i);
                            if ( ch == '/' ){
                                status = 11; // EOL 
                                for ( int time = 0; time < 2; time++ ){ // 2 ʸʬ򥳥ȤȤƵϿ
                                    map.append(CodeLineMapForJava.EOL_COMMENT);
                                }
                            }
                            else if ( ch == '*' ){ // Traditional Ȥ Javadoc Τ줫
                                // ³ʸ * Ǥäơμ / Ǥʤ Javadoc
                                // ʤ Traditional 
                                if ( i+2 < line.length() && line.charAt(i+1) == '*' && line.charAt(i+2) != '/' ){
                                    status = 13; // Javadoc ... /* θ夬 2 ʸʾĤäƤơ/* μ * ǡμ / ʳξ
                                }
                                else if ( i + 2 == line.length() && line.charAt(i+1) == '*' ){
                                    status = 13; // Javadoc ... /* θ夬 1 ʸĤäƤ餺Ǹ 1 ʸ * ξ
                                }
                                else{
                                    status = 12; // Traditional  ...  Javadoc Ȥʤʤ
                                }
                                for ( int time = 0; time < 2; time++ ){ // 2 ʸʬ򥳥ȤȤƵϿ
                                    map.append( status == 12 ? CodeLineMapForJava.TRADITIONAL_COMMENT : CodeLineMapForJava.JAVADOC_COMMENT );
                                } 
                            }
                        }
                        if ( status == 1 ){ // ݻʤɤߤʬϤä᤹
                            i--;
                            map.append(CodeLineMap.CODE);
                        }
                        break;
                    case '\'' :
                        if ( i+1 < line.length() ){
                            // ̤ '"' ξ򥹥å
                            if ( line.charAt(i+1) == '"' ){
                                i += 2;
                                for ( int time = 0; time < 3; time++ ){ // 3 ʸʬ򥳡ɤȤƵϿ
                                    map.append(CodeLineMap.CODE);
                                }
                            }
                            else if ( line.charAt(i+1) == '\\' ){ // ʸξƱͤ˥å
                                i += 3;
                                for ( int time = 0; time < 4; time++ ){ // 4 ʸʬ򥳡ɤȤƵϿ
                                    map.append(CodeLineMap.CODE);
                                }
                            }
                        }
                        break;
                    case '"' :
                        status = 100; // -->ʸλϤޤ
                        map.append(CodeLineMap.CODE);
                        break;
                    default:
                        status = 1; // -->̾Υ
                        isCodeIncluded = true;          
                        map.append(CodeLineMap.CODE);
                    }
                    break;
                case 11: // EOL 
                    // ޤǥåפƽ֤
                    while ( i++ < line.length() ){
                        map.append(CodeLineMapForJava.EOL_COMMENT);
                    }
                    status = 0; 
                    break;
                case 12: // Traditional 
                case 13: // Javadoc
                    map.append( status == 12 ? CodeLineMapForJava.TRADITIONAL_COMMENT : CodeLineMapForJava.JAVADOC_COMMENT );
                    if ( ch == '*' ){
                        //  1 ʸĴ٤Ƽξ֤
                        if ( i+1 < line.length() ){
                            ch = line.charAt(i+1);
                            if ( ch == '/' ){
                                i++;
                                map.append( status == 12 ? CodeLineMapForJava.TRADITIONAL_COMMENT : CodeLineMapForJava.JAVADOC_COMMENT );
                                status = isCodeIncluded ? 1 : 0; // Ȥξ֤
                            }
                        }
                    }
                    break;
                case 100: // ʸ
                    map.append(CodeLineMap.CODE);
                    switch( ch ){
                    case '"' :
                        status = 1;
                        break;
                    case '\\' :
                        i++; // 1 ʸå
                        map.append(CodeLineMap.CODE);
                    }
                    break;
                }
                i++;
            }
            
            // ԤβϤä顤η̤ CodeLineMapForJava ֥ȤȤƹۤꥹȤɲäƤ
            add(new CodeLineMapForJava(new String(map)));
        }
        
        reader.close();
    }    
    
}
